(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@scullyio/scully'), require('highlight.js'), require('fs'), require('jsdom'), require('marked')) :
    typeof define === 'function' && define.amd ? define('scully-multi-markdown-page-builder-plugin', ['exports', '@scullyio/scully', 'highlight.js', 'fs', 'jsdom', 'marked'], factory) :
    (global = global || self, factory(global['scully-multi-markdown-page-builder-plugin'] = {}, global['@scullyio/scully'], global.highlight.js, global.fs, global.jsdom, global.marked));
}(this, (function (exports, scully, highlight, fs, jsdom, marked) { 'use strict';

    highlight = highlight && Object.prototype.hasOwnProperty.call(highlight, 'default') ? highlight['default'] : highlight;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var scullyBegin = '<!--scullyContent-begin-->';
    var scullyEnd = '<!--scullyContent-end-->';
    function renderPlugin(html, route) {
        return __awaiter(this, void 0, void 0, function () {
            var sectionBuilders, attr, additionalHTML, sectionBuilders_1, sectionBuilders_1_1, builder, markdownHtmls, _a, _b, markdownFileSource, originalFile, options, markdownHtml, htmlWithNgAttr;
            var e_1, _c, e_2, _d;
            return __generator(this, function (_e) {
                sectionBuilders = route.config.sectionBuilders;
                try {
                    attr = '';
                    try {
                        attr = getIdAttrName(html.split('<scully-content')[1].split('>')[0].trim());
                    }
                    catch (e) {
                        scully.logWarn("\n        ----------------\n        Error, missing \"" + scully.yellow('<scully-content>') + "\" in route \"" + scully.yellow(route.route) + "\"\n        without <scully-content> we can not render this route.\n        Make sure it is in there, and not inside any conditionals (*ngIf)\n        You can check this by opening \"" + scully.yellow("://localhost:4200/" + route.route) + "\"\n        when you serve your app with " + scully.yellow('ng serve') + " and then in the browsers console run:\n        " + scully.yellow("document.querySelector('scully-content')") + "\n        ----------------\n        ");
                    }
                    additionalHTML = '';
                    try {
                        for (sectionBuilders_1 = __values(sectionBuilders), sectionBuilders_1_1 = sectionBuilders_1.next(); !sectionBuilders_1_1.done; sectionBuilders_1_1 = sectionBuilders_1.next()) {
                            builder = sectionBuilders_1_1.value;
                            markdownHtmls = [];
                            try {
                                for (_a = (e_2 = void 0, __values(builder.markdownFileSources)), _b = _a.next(); !_b.done; _b = _a.next()) {
                                    markdownFileSource = _b.value;
                                    originalFile = fs.readFileSync(markdownFileSource, 'utf-8');
                                    options = {
                                        highlight: function (code, language) {
                                            var hljs = highlight;
                                            var validLanguage = hljs.getLanguage(language)
                                                ? language
                                                : 'plaintext';
                                            return hljs.highlight(validLanguage, code).value;
                                        },
                                        pedantic: false,
                                        gfm: true,
                                        breaks: false,
                                        sanitize: false,
                                        smartLists: true,
                                        smartypants: false,
                                        xhtml: false
                                    };
                                    markdownHtml = marked.parse(originalFile, options);
                                    markdownHtmls.push(markdownHtml);
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                            additionalHTML = additionalHTML + builder.sectionBuilder(markdownHtmls);
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (sectionBuilders_1_1 && !sectionBuilders_1_1.done && (_c = sectionBuilders_1.return)) _c.call(sectionBuilders_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    htmlWithNgAttr = addNgIdAttribute(additionalHTML, attr);
                    return [2 /*return*/, insertContent(scullyBegin, scullyEnd, html, htmlWithNgAttr, getScript(attr))];
                }
                catch (e) {
                    scully.logWarn("Error, while rendering content for \"" + scully.yellow(route.route) + "\" from files: \"" + scully.yellow(sectionBuilders.map(function (builder) { return builder.markdownFileSources; })) + "\"");
                    console.error(e);
                }
                return [2 /*return*/];
            });
        });
    }
    function addNgIdAttribute(html, id) {
        if (!id) {
            return html;
        }
        try {
            var dom = new jsdom.JSDOM(html, { runScripts: 'outside-only' });
            var window_1 = dom.window;
            var document_1 = window_1.document;
            var walk = document_1.createTreeWalker(document_1.body);
            var cur = walk.currentNode;
            while (cur) {
                if (cur.nodeType === 1) {
                    cur.setAttribute(id, '');
                }
                cur = walk.nextNode();
            }
            return document_1.body.innerHTML;
        }
        catch (e) {
            console.error(e);
        }
        return '';
    }
    function getIdAttrName(attrs) {
        try {
            return (attrs &&
                attrs
                    .split(' ')
                    .find(function (at) { return at.trim().startsWith('_ngcontent'); })
                    .split('=')[0]);
        }
        catch (_a) {
            return '6';
        }
    }
    function getScript(attr) {
        // tslint:disable-next-line:no-unused-expression
        return "<script>try {window['scullyContent'] = {cssId:\"" + attr + "\",html:document.body.innerHTML.split('<!--scullyContent-begin-->')[1].split('<!--scullyContent-end-->')[0]};} catch(e) {console.error('scully could not parse content');}</script>";
    }
    function insertContent(startTag, endTag, html, insertText) {
        var extras = [];
        for (var _i = 4; _i < arguments.length; _i++) {
            extras[_i - 4] = arguments[_i];
        }
        try {
            var _a = __read(html.split(startTag), 2), openingText = _a[0], rest = _a[1];
            var _b = __read(rest.split(endTag), 2), takeout = _b[0], endText = _b[1];
            return __spread([openingText, startTag, insertText, endTag], extras, [endText]).join('');
        }
        catch (e) { }
        /** warning is already handled, only put in stub content. */
        // logWarn(`missing "${yellow('<scully-content>')}"`);
        return "<h1>Scully could not find the &lt.scully-content&gt. tag in this page.</h1>\n  <p>This error can happen when you forgot to put the  mandatory \"scully-content\" in the component that is rendering this page?</p>\n  <p>Or when the tag is not shown on page load. Did you put it inside an `*ngIf`?</p>\n  ";
    }

    var MultiMarkdownPageBuilderPluginName = 'MultiMarkdownPageBuilderPlugin';

    function routerPlugin(route, config) {
        var additionalPostRenderers = config.postRenderers ? config.postRenderers : [];
        var routes = [
            {
                type: MultiMarkdownPageBuilderPluginName,
                route: route === '' ? '/' : route,
                config: config,
                postRenderers: __spread([MultiMarkdownPageBuilderPluginName], additionalPostRenderers),
                title: config.title
            }
        ];
        return Promise.resolve(routes);
    }

    var renderValidator = function (config) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, []];
    }); }); };

    var routerValidator = function (config) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (config.sectionBuilders === undefined || !Array.isArray(config.sectionBuilders)) {
                return [2 /*return*/, ["Missing a sectionBuilders array in the " + MultiMarkdownPageBuilderPluginName + " config."]];
            }
            else {
                return [2 /*return*/, config.sectionBuilders.reduce(function (errors, sectionBuilder) {
                        if (sectionBuilder.sectionBuilder === undefined || !(sectionBuilder.sectionBuilder instanceof Function)) {
                            errors.push("Missing sectionBuilder function type in section builder: " + sectionBuilder);
                        }
                        if (sectionBuilder.markdownFileSources === undefined || !Array.isArray(sectionBuilder.markdownFileSources)) {
                            errors.push("Missing markdownFileSources array type in section builder: " + sectionBuilder);
                        }
                        return errors;
                    }, [])];
            }
            return [2 /*return*/];
        });
    }); };

    var MultiMarkdownPageBuilderPlugin = MultiMarkdownPageBuilderPluginName;
    scully.registerPlugin('render', MultiMarkdownPageBuilderPlugin, renderPlugin, renderValidator);
    scully.registerPlugin('router', MultiMarkdownPageBuilderPlugin, routerPlugin, routerValidator);

    /**
     * Creates a section of a page from a single markdown file, and adds the passed css selectors for inserting layout customization.
     *
     * Example markdown source file:
     * ```md
     * # Markdown Title Content
     * ```
     * Example usage:
     * ```typescript
     * export const config: ScullyConfig = {
     *   // ...
     *   routes: {
     *     '/path': {
     *       type: MultiMarkdownPageBuilderPlugin,
     *       sectionBuilders: [
     *         createSingleMarkdownSection('./homepage/installation.md', { containerDivId: 'installationContainer', elementDivId: 'installationItem' }),
     *       ]
     *     }
     *   }
     * };
     * ```
     * Example output:
     * ```html
     * <div id="installationContainer">
     *  <div id="installationItem">
     *      <h1>Markdown Title Content</h1>
     *  </div>
     * </div>
     * ```
     * @param {string} markdownFileSource source of the markdown file to be converted into HTML, then passed into the sectionBuilder
     * @param {SingleMarkdownSectionBuilderExtras} extras The `containerIdAttribute` will be attached as the `id` attribute value for the container div.  The `elementIdAttribute` will be attached as the `id` attribute value for the interior element div.  Passing `null` for either will omit the selector.
     * @returns A `MarkdownSectionBuilder` that will be used by the plugin to create the single markdown section.
     */
    function createSingleMarkdownSection(markdownFileSource, extras) {
        return {
            sectionBuilder: function (markdownHtmls) {
                var containerIdAttribute = extras.containerDivId === null ? '' : " id=\"" + extras.containerDivId + "\"";
                var elementIdAttribute = extras.elementDivId === null ? '' : " id=\"" + extras.elementDivId + "\"";
                return "<div" + containerIdAttribute + "><div" + elementIdAttribute + ">" + markdownHtmls[0] + "</div></div>";
            },
            markdownFileSources: [markdownFileSource],
            extras: extras
        };
    }

    /**
     * Creates a section of a page from multiple markdown files, and adds the passed css selectors for inserting layout customization.
     *
     * Example markdown source files:
     * ```md
     * // ./sourceDir/file1.md
     * # First Markdown Title Content
     * ```
     * ```md
     * // ./sourceDir/file2.md
     * # Second Markdown Title Content
     * ```
     * Example usage:
     * ```typescript
     * export const config: ScullyConfig = {
     *   // ...
     *   routes: {
     *     '/path': {
     *       type: MultiMarkdownPageBuilderPlugin,
     *       sectionBuilders: [
     *         createMultipleMarkdownSection(['./sourceDir/file1.md', './sourceDir/file2.md'], { containerDivId: 'gridContainer', elementsDivClass: 'grid-item' })
     *       ]
     *     }
     *   }
     * };
     * ```
     * Example output:
     * ```html
     * <div id="gridContainer">
     *  <div id="element1" class="grid-item">
     *      <h1>First Markdown Title Content</h1>
     *  </div>
     *  <div id="element2" class="grid-item">
     *      <h1>Second Markdown Title Content</h1>
     *  </div>
     * </div>
     * ```
     * @param {string[]} markdownFileSources source of the markdown files to be converted into HTML, then passed into the sectionBuilder
     * @param {SingleMarkdownSectionBuilderExtras} extras The `containerIdAttribute` will be attached as the `id` attribute value for the container div.  The `elementsDivClass` will be attached as the `class` attribute value for the interior element div.  Passing `null` for either will omit the selector.
     * @returns A `MarkdownSectionBuilder` that will be used by the plugin to create the single markdown section.
     */
    function createMultipleMarkdownSection(markdownFileSources, extras) {
        return {
            sectionBuilder: function (markdownHtmls) {
                var markdownFileIndex = 1;
                var combinedMarkdownHtml = markdownHtmls.reduce(function (combined, currentMarkdownHtml) {
                    var idAttribute = " id=\"element" + markdownFileIndex++ + "\"";
                    var classAttribute = extras.elementsDivClass === null ? '' : " class=\"" + extras.elementsDivClass + "\"";
                    return combined + ("<div" + idAttribute + classAttribute + ">" + currentMarkdownHtml + "</div>");
                }, '');
                var idAttribute = extras.containerDivId === null ? '' : " id=\"" + extras.containerDivId + "\"";
                return "<div" + idAttribute + ">" + combinedMarkdownHtml + "</div>";
            },
            markdownFileSources: markdownFileSources,
            extras: extras
        };
    }

    exports.MultiMarkdownPageBuilderPlugin = MultiMarkdownPageBuilderPlugin;
    exports.createMultipleMarkdownSection = createMultipleMarkdownSection;
    exports.createSingleMarkdownSection = createSingleMarkdownSection;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=scully-multi-markdown-page-builder-plugin.umd.js.map
