export interface MultiMarkdownPageBuilderPluginConfig {
    sectionBuilders: MarkdownSectionBuilder[];
    title: string | undefined;
    postRenderers: string[] | undefined;
}
export declare type SectionBuilder = (markdownHtmls: string[]) => string;
export interface MarkdownSectionBuilder {
    sectionBuilder: SectionBuilder;
    markdownFileSources: string[];
    extras: any;
}
